Index: trunk/kBuild/header.kmk
===================================================================
--- trunk/kBuild/header.kmk	(revision 2085)
+++ trunk/kBuild/header.kmk	(revision 2086)
@@ -177,5 +177,5 @@
 # build types. (PORTME)
 #
-KBUILD_OSES   := darwin dragonfly freebsd l4 linux netbsd nt openbsd os2 solaris win
+KBUILD_OSES   := darwin dos dragonfly freebsd l4 linux netbsd nt openbsd os2 solaris win
 KBUILD_ARCHES := x86 amd64 sparc32 sparc64 s390 s390x ppc32 ppc64 mips32 mips64 ia64 hppa32 hppa64 arm alpha
 
Index: trunk/kBuild/tools/OPENWATCOM.kmk
===================================================================
--- trunk/kBuild/tools/OPENWATCOM.kmk	(revision 2085)
+++ trunk/kBuild/tools/OPENWATCOM.kmk	(revision 2086)
@@ -124,4 +124,5 @@
 TOOL_OPENWATCOM_ASOBJSUFF        ?= .obj
 TOOL_OPENWATCOM_ASFLAGS          ?= -zq
+TOOL_OPENWATCOM_ASFLAGS.dos      ?= -bt=dos
 TOOL_OPENWATCOM_ASFLAGS.os2      ?= -bt=os2
 TOOL_OPENWATCOM_ASFLAGS.win      ?= -bt=nt
@@ -129,13 +130,19 @@
 TOOL_OPENWATCOM_COBJSUFF         ?= .obj
 TOOL_OPENWATCOM_CFLAGS           ?= -zq
+TOOL_OPENWATCOM_CFLAGS.dos       ?= -bt=dos
 TOOL_OPENWATCOM_CFLAGS.os2       ?= -bt=os2
 TOOL_OPENWATCOM_CFLAGS.win       ?= -bt=nt
-TOOL_OPENWATCOM_CINCS            ?= $(PATH_TOOL_OPENWATCOM)/h
+ifdef PATH_TOOL_OPENWATCOM
+ TOOL_OPENWATCOM_CINCS           ?= $(PATH_TOOL_OPENWATCOM)/h
+endif
 
 TOOL_OPENWATCOM_CXXOBJSUFF       ?= .obj
 TOOL_OPENWATCOM_CXXFLAGS         ?= -zq
+TOOL_OPENWATCOM_CXXFLAGS.dos     ?= -bt=dos
 TOOL_OPENWATCOM_CXXFLAGS.os2     ?= -bt=os2
 TOOL_OPENWATCOM_CXXFLAGS.win     ?= -bt=nt
-TOOL_OPENWATCOM_CXXINCS          ?= $(PATH_TOOL_OPENWATCOM)/h
+ifdef PATH_TOOL_OPENWATCOM
+ TOOL_OPENWATCOM_CXXINCS         ?= $(PATH_TOOL_OPENWATCOM)/h
+endif
 
 TOOL_OPENWATCOM_RCOBJSUFF        ?= .res
@@ -143,5 +150,7 @@
 TOOL_OPENWATCOM_RCFLAGS.os2      ?= -bt=os2
 TOOL_OPENWATCOM_RCFLAGS.win      ?= -bt=nt
-TOOL_OPENWATCOM_RCINCS           ?= $(PATH_TOOL_OPENWATCOM)/h
+ifdef PATH_TOOL_OPENWATCOM
+ TOOL_OPENWATCOM_RCINCS          ?= $(PATH_TOOL_OPENWATCOM)/h
+endif
 
 TOOL_OPENWATCOM_ARFLAGS          ?= -q
@@ -149,4 +158,5 @@
 
 TOOL_OPENWATCOM_LDFLAGS          ?= -zq -y
+TOOL_OPENWATCOM_LDFLAGS.dos      ?= -bt=dos
 TOOL_OPENWATCOM_LDFLAGS.os2      ?= -bt=os2
 TOOL_OPENWATCOM_LDFLAGS.win      ?= -bt=nt
Index: trunk/kBuild/tools/WATCOMC11C.kmk
===================================================================
--- trunk/kBuild/tools/WATCOMC11C.kmk	(revision 2085)
+++ trunk/kBuild/tools/WATCOMC11C.kmk	(revision 2086)
@@ -117,24 +117,25 @@
 TOOL_WATCOMC11C_COBJSUFF         ?= .obj
 TOOL_WATCOMC11C_CFLAGS           ?= -zq
+TOOL_WATCOMC11C_CFLAGS.dos       ?= -bt=dos
 TOOL_WATCOMC11C_CFLAGS.os2       ?= -bt=os2
 TOOL_WATCOMC11C_CFLAGS.win       ?= -bt=nt
-TOOL_WATCOMC11C_CFLAGS.debug     ?=
-TOOL_WATCOMC11C_CFLAGS.release   ?=
-TOOL_WATCOMC11C_CINCS            ?= $(PATH_TOOL_WATCOMC11C)/h
-TOOL_WATCOMC11C_CDEFS            ?=
+ifdef PATH_TOOL_WATCOMC11C
+ TOOL_WATCOMC11C_CINCS           ?= $(PATH_TOOL_WATCOMC11C)/h
+endif
 
 TOOL_WATCOMC11C_CXXOBJSUFF       ?= .obj
 TOOL_WATCOMC11C_CXXFLAGS         ?= -zq
+TOOL_WATCOMC11C_CXXFLAGS.dos     ?= -bt=dos
 TOOL_WATCOMC11C_CXXFLAGS.os2     ?= -bt=os2
 TOOL_WATCOMC11C_CXXFLAGS.win     ?= -bt=nt
-TOOL_WATCOMC11C_CXXFLAGS.debug   ?=
-TOOL_WATCOMC11C_CXXFLAGS.release ?=
-TOOL_WATCOMC11C_CXXINCS          ?= $(PATH_TOOL_WATCOMC11C)/h
-TOOL_WATCOMC11C_CXXDEFS          ?=
+ifdef PATH_TOOL_WATCOMC11C
+ TOOL_WATCOMC11C_CXXINCS         ?= $(PATH_TOOL_WATCOMC11C)/h
+endif
 
 TOOL_WATCOMC11C_RCOBJSUFF        ?= .res
 TOOL_WATCOMC11C_RCFLAGS          ?= -r
-TOOL_WATCOMC11C_RCINCS           ?= $(PATH_TOOL_WATCOMC11C)/h
-TOOL_WATCOMC11C_RCDEFS           ?=
+ifdef PATH_TOOL_WATCOMC11C
+ TOOL_WATCOMC11C_RCINCS          ?= $(PATH_TOOL_WATCOMC11C)/h
+endif
 
 TOOL_WATCOMC11C_ARFLAGS          ?= -q
@@ -142,7 +143,7 @@
 
 TOOL_WATCOMC11C_LDFLAGS          ?= -zq -y
+TOOL_WATCOMC11C_LDFLAGS.dos      ?= -bt=dos
 TOOL_WATCOMC11C_LDFLAGS.os2      ?= -bt=os2
 TOOL_WATCOMC11C_LDFLAGS.win      ?= -bt=nt
-TOOL_WATCOMC11C_LDFLAGS.debug    ?=
 
 