Index: /trunk/doc/ReleaseNotes.os2
===================================================================
--- /trunk/doc/ReleaseNotes.os2	(revision 2099)
+++ /trunk/doc/ReleaseNotes.os2	(revision 2100)
@@ -52,43 +52,50 @@
 
         o New functions (might not be 100% correct):
-          __bindtextdomain(), __dcgettext(), __dcigettext(),
-          __dcngettext(), __dgettext(), __dngettext(), __gettext(),
-          __gettext_extract_plural(), __gettext_free_exp(), __gettextparse(),
-          _nl_make_l10nflist(), __ngettext(), __textdomain(), _nl_locale_name(),
-          on_exit(), nanosleep(), wmemcpy(), wmemchr(), wmemcmp(), wmemmove(),
-          wmemset(), gethrtime(), _nl_expand_alias(), _nl_explode_name(),
-          _nl_normalize_codeset(), __fbufsize(), __fpending(), getpriority(),
-          setpriority(), nice(), sysctl(), sysctlbyname(), sysctlnametomib(),
-          fchmod(), _chdir_os2(), fts_children(), fts_close(), fts_get_clientptr(),
-          fts_get_stream(), fts_open(), fts_read(), fts_set(), fts_set_clientptr(),
-          mkfifo(), futimes(), _getenv_int(), _getenv_long(), _getenv_longlong(),
-          ftok(), semctl(), semget(), semop(), shmat(), shmctl(), shmdt(), shmget(),
-          acosf(), acosh(), acoshf(), asinf(), asinh(), asinhf(), atan2f(), atanf(),
-          atanh(), atanhf(), cabs(), cabsf(), cbrtf(), ceilf(), cimag(), cimagf(),
-          cimagl(), conj(), conjf(), conjl(), cosf(), coshf(), creal(), crealf(),
-          creall(), erf(), erfc(), erfcf(), erff(), exp2(), exp2f(), expf(),
-          expm1(), expm1f(), truncf(), fabsf(), fdim(), fdimf(), fdiml(), fegetenv(),
-          feholdexcept(), feraiseexcept(), fesetexceptflag(), feupdateenv(),
-          floorf(), fma(), fmaf(), fmal(), fmax(), fmaxf(), fmaxl(), fmin(),
-          fminf(), fminl(), fmodf(), frexpf(), hypotf(), ilogb(), ilogbf(),
-          ilogbl(), ldexpf(), lgamma(), lgammaf(), llrint(), llrintf(), llround(),
-          llroundf(), llroundl(), log10f(), log1p(), log1pf(), logb(), logbf(),
-          logf(), lrint(), lrintf(), lround(), lroundf(), lroundl(), modff(),
-          nearbyint(), nearbyintf(), nexttoward(), nexttowardf(), powf(),
-          remainder(), remainderf(), remquo(), remquof(), rintf(), round(),
-          roundf(), roundl(), scalbf(), scalbln(), scalblnf(), scalblnl(),
-          scalbn(), scalbnf(), scalbnl(), signgam(), sinf(), sinhf(), sqrtf(),
-          tanf(), tanhf(), tgamma(), drem(), dremf(), finite(), finitef(),
-          gamma(), gammaf(), gammaf_r(), gamma_r(), j0(), j0f(), j1(), j1f(),
-          jn(), jnf(), lgammaf_r(), lgamma_r(), scalb(), significand(),
-          significandf(), powl(), y0(), y0f(), y1(), y1f(), yn(), ynf(),
-          arc4random(), arc4random_addrandom(), arc4random_stir(),
-          _mktemp(), mkdtemp(), mkstemps(), clearerr_unlocked(),
-          feof_unlocked(), ferror_unlocked(), fgetc_unlocked(),
-          fileno_unlocked(), flockfile(), ftrylockfile(), funlockfile(),
-          getchar_unlocked(), getc_unlocked(), putchar_unlocked(),
-          fputc_unlocked(), putc_unlocked(), fputs_unlocked(),
-          puts_unlocked() and fread_unlocked().
-
+          __bindtextdomain(), __dcgettext(), __dcigettext(), 
+          __dcngettext(), __dgettext(), __dngettext(), __gettext(), 
+          __gettext_extract_plural(), __gettext_free_exp(), 
+          __gettextparse(), _nl_make_l10nflist(), __ngettext(), 
+          __textdomain(), _nl_locale_name(), on_exit(), nanosleep(), 
+          wmemcpy(), wmemchr(), wmemcmp(), wmemmove(), wmemset(), 
+          gethrtime(), _nl_expand_alias(), _nl_explode_name(), 
+          _nl_normalize_codeset(), __fbufsize(), __fpending(), 
+          getpriority(), setpriority(), nice(), sysctl(), 
+          sysctlbyname(), sysctlnametomib(), fchmod(), _chdir_os2(), 
+          fts_children(), fts_close(), fts_get_clientptr(), 
+          fts_get_stream(), fts_open(), fts_read(), fts_set(), 
+          fts_set_clientptr(), mkfifo(), futimes(), _getenv_int(), 
+          _getenv_long(), _getenv_longlong(), ftok(), semctl(), 
+          semget(), semop(), shmat(), shmctl(), shmdt(), shmget(), 
+          acosf(), acosh(), acoshf(), asinf(), asinh(), asinhf(), 
+          atan2f(), atanf(), atanh(), atanhf(), cabs(), cabsf(), 
+          cbrtf(), ceilf(), cimag(), cimagf(), cimagl(), conj(), 
+          conjf(), conjl(), cosf(), coshf(), creal(), crealf(), 
+          creall(), erf(), erfc(), erfcf(), erff(), exp2(), exp2f(), 
+          expf(), expm1(), expm1f(), truncf(), fabsf(), fdim(), 
+          fdimf(), fdiml(), fegetenv(), feholdexcept(), 
+          feraiseexcept(), fesetexceptflag(), feupdateenv(), floorf(), 
+          fma(), fmaf(), fmal(), fmax(), fmaxf(), fmaxl(), fmin(), 
+          fminf(), fminl(), fmodf(), frexpf(), hypotf(), ilogb(), 
+          ilogbf(), ilogbl(), ldexpf(), lgamma(), lgammaf(), llrint(), 
+          llrintf(), llround(), llroundf(), llroundl(), log10f(), 
+          log1p(), log1pf(), logb(), logbf(), logf(), lrint(), 
+          lrintf(), lround(), lroundf(), lroundl(), modff(), 
+          nearbyint(), nearbyintf(), nexttoward(), nexttowardf(), 
+          powf(), remainder(), remainderf(), remquo(), remquof(), 
+          rintf(), round(), roundf(), roundl(), scalbf(), scalbln(), 
+          scalblnf(), scalblnl(), scalbn(), scalbnf(), scalbnl(), 
+          signgam(), sinf(), sinhf(), sqrtf(), tanf(), tanhf(), 
+          tgamma(), drem(), dremf(), finite(), finitef(), gamma(), 
+          gammaf(), gammaf_r(), gamma_r(), j0(), j0f(), j1(), j1f(), 
+          jn(), jnf(), lgammaf_r(), lgamma_r(), scalb(), 
+          significand(), significandf(), powl(), y0(), y0f(), y1(), 
+          y1f(), yn(), ynf(), arc4random(), arc4random_addrandom(), 
+          arc4random_stir(), _mktemp(), mkdtemp(), mkstemps(), 
+          clearerr_unlocked(), feof_unlocked(), ferror_unlocked(),  
+          fgetc_unlocked(), fileno_unlocked(), flockfile(), 
+          ftrylockfile(), funlockfile(), getchar_unlocked(), 
+          getc_unlocked(), putchar_unlocked(), fputc_unlocked(), 
+          putc_unlocked(), fputs_unlocked(), puts_unlocked() and 
+          fread_unlocked().
 
     Removed features:
@@ -257,4 +264,5 @@
           _UTF8_wcsnrtombs(), digittoint(), isideogram(),
           isrune(), iswalnum(), iswalpha(), iswascii(),
+
           iswblank(), iswcntrl(), iswctype(), iswdigit(),
           iswgraph(), iswhexnumber(), iswideogram(), iswlower(),