Index: /trunk/src/kmk/kmkbuiltin/append.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/append.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/append.c	(revision 2113)
@@ -27,13 +27,15 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#ifndef kmk_builtin_append
+# include "make.h"
+# include "filedef.h"
+# include "variable.h"
+#else
+# include "config.h"
+#endif
 #include <string.h>
 #include <stdio.h>
 #include "err.h"
 #include "kmkbuiltin.h"
-#ifndef kmk_builtin_append
-# include "make.h"
-# include "filedef.h"
-# include "variable.h"
-#endif
 
 
Index: /trunk/src/kmk/kmkbuiltin/cat.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cat.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/cat.c	(revision 2113)
@@ -51,4 +51,5 @@
 #endif
 
+#include "config.h"
 #ifndef _MSC_VER
 # include <sys/param.h>
Index: /trunk/src/kmk/kmkbuiltin/chmod.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/chmod.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/chmod.c	(revision 2113)
@@ -42,4 +42,5 @@
 /*__FBSDID("$FreeBSD: src/bin/chmod/chmod.c,v 1.33 2005/01/10 08:39:20 imp Exp $");*/
 
+#include "config.h"
 #include <sys/types.h>
 #include <sys/stat.h>
Index: /trunk/src/kmk/kmkbuiltin/cmp.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cmp.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/cmp.c	(revision 2113)
@@ -35,4 +35,5 @@
 __RCSID("$NetBSD: cmp.c,v 1.15 2006/01/19 20:44:57 garbled Exp $"); */
 
+#include "config.h"
 #include <sys/types.h>
 #include "err.h"
Index: /trunk/src/kmk/kmkbuiltin/cmp_util.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cmp_util.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/cmp_util.c	(revision 2113)
@@ -36,4 +36,5 @@
 	The Regents of the University of California.  All rights reserved.\n");*/
 
+#include "config.h"
 #include <sys/types.h>
 #include <sys/stat.h>
Index: /trunk/src/kmk/kmkbuiltin/cp.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cp.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/cp.c	(revision 2113)
@@ -60,4 +60,5 @@
  */
 
+#include "config.h"
 #include <sys/types.h>
 #include <sys/stat.h>
Index: /trunk/src/kmk/kmkbuiltin/cp_utils.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/cp_utils.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/cp_utils.c	(revision 2113)
@@ -36,4 +36,5 @@
 #endif /* not lint */
 
+#include "config.h"
 #ifndef _MSC_VER
 # include <sys/param.h>
Index: /trunk/src/kmk/kmkbuiltin/darwin.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/darwin.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/darwin.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include <sys/stat.h>
 #include <unistd.h>
Index: /trunk/src/kmk/kmkbuiltin/echo.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/echo.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/echo.c	(revision 2113)
@@ -42,8 +42,9 @@
 #endif
 
+#include "config.h"
 #include <sys/types.h>
 #ifndef _MSC_VER
 #include <sys/uio.h>
-#endif 
+#endif
 
 #include <stdio.h>
@@ -57,5 +58,5 @@
 #else
 #include "mscfakes.h"
-#endif 
+#endif
 
 #ifndef IOV_MAX
@@ -79,5 +80,5 @@
 	write(STDERR_FILENO, "\n", 1);
 }
-	
+
 int
 kmk_builtin_echo(int argc, char *argv[])
@@ -107,5 +108,5 @@
 	while (argv[0] != NULL) {
 		size_t len;
-		
+
 		len = strlen(argv[0]);
 
Index: /trunk/src/kmk/kmkbuiltin/err.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/err.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/err.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include <stdio.h>
 #include <stdarg.h>
Index: /trunk/src/kmk/kmkbuiltin/expr.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/expr.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/expr.c	(revision 2113)
@@ -7,4 +7,5 @@
  */
 
+#include "config.h"
 #include <stdio.h>
 #include <stdlib.h>
Index: /trunk/src/kmk/kmkbuiltin/fts.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/fts.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/fts.c	(revision 2113)
@@ -43,4 +43,5 @@
 #endif /* LIBC_SCCS and not lint */
 
+#include "config.h"
 /*#include "namespace.h"*/
 #ifndef _MSC_VER
Index: /trunk/src/kmk/kmkbuiltin/install.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/install.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/install.c	(revision 2113)
@@ -47,4 +47,5 @@
 #endif
 
+#include "config.h"
 #ifndef _MSC_VER
 # include <sys/param.h>
Index: /trunk/src/kmk/kmkbuiltin/kDepIDB.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/kDepIDB.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/kDepIDB.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include <stdio.h>
 #include <stdlib.h>
Index: /trunk/src/kmk/kmkbuiltin/kbuild_protection.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/kbuild_protection.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/kbuild_protection.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include <sys/types.h>
 #include <stdlib.h>
Index: /trunk/src/kmk/kmkbuiltin/kbuild_version.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/kbuild_version.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/kbuild_version.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include "kmkbuiltin.h"
 #include <string.h>
Index: /trunk/src/kmk/kmkbuiltin/ln.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/ln.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/ln.c	(revision 2113)
@@ -47,4 +47,5 @@
 #include <sys/stat.h>
 
+#include "config.h"
 #include "err.h"
 #include <errno.h>
Index: /trunk/src/kmk/kmkbuiltin/md5sum.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/md5sum.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/md5sum.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include <string.h>
 #include <stdio.h>
Index: /trunk/src/kmk/kmkbuiltin/mkdir.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/mkdir.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/mkdir.c	(revision 2113)
@@ -42,4 +42,5 @@
 #endif
 
+#include "config.h"
 #include <sys/types.h>
 #include <sys/stat.h>
Index: /trunk/src/kmk/kmkbuiltin/mscfakes.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/mscfakes.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/mscfakes.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include <stdarg.h>
 #include <stdio.h>
Index: /trunk/src/kmk/kmkbuiltin/mv.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/mv.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/mv.c	(revision 2113)
@@ -47,4 +47,5 @@
 #endif
 
+#include "config.h"
 #include <sys/types.h>
 #ifndef _MSC_VER
Index: /trunk/src/kmk/kmkbuiltin/printf.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/printf.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/printf.c	(revision 2113)
@@ -46,4 +46,5 @@
 #endif*/ /* not lint */
 
+#include "config.h"
 #include <sys/types.h>
 
Index: /trunk/src/kmk/kmkbuiltin/redirect.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/redirect.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/redirect.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include <stdio.h>
 #include <stdlib.h>
@@ -260,5 +261,5 @@
                     char *pszEqual = strchr(envp[i], '=');
                     char *pszCopy;
-                    
+
                     if (pszEqual)
                         *pszEqual = '\0';
@@ -267,9 +268,9 @@
                         *pszEqual = '=';
 
-#if defined(_MSC_VER) || defined(__OS2__) 
+#if defined(_MSC_VER) || defined(__OS2__)
                     putenv(pszCopy);
 #else
                     unsetenv(pszCopy);
-#endif 
+#endif
                     free(pszCopy);
                 }
Index: /trunk/src/kmk/kmkbuiltin/rm.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/rm.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/rm.c	(revision 2113)
@@ -42,4 +42,5 @@
 #endif
 
+#include "config.h"
 #include <sys/stat.h>
 #ifndef _MSC_VER
Index: /trunk/src/kmk/kmkbuiltin/rmdir.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/rmdir.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/rmdir.c	(revision 2113)
@@ -44,4 +44,5 @@
 #endif
 
+#include "config.h"
 #include "err.h"
 #include <stdio.h>
Index: /trunk/src/kmk/kmkbuiltin/setmode.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/setmode.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/setmode.c	(revision 2113)
@@ -43,4 +43,5 @@
 
 /*#include "namespace.h"*/
+#include "config.h"
 #include <sys/types.h>
 #include <sys/stat.h>
Index: /trunk/src/kmk/kmkbuiltin/sleep.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/sleep.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/sleep.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include <stdio.h>
 #include <stdlib.h>
Index: /trunk/src/kmk/kmkbuiltin/solfakes.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/solfakes.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/solfakes.c	(revision 2113)
@@ -27,4 +27,5 @@
 *   Header Files                                                               *
 *******************************************************************************/
+#include "config.h"
 #include <errno.h>
 #include <stdio.h>
Index: /trunk/src/kmk/kmkbuiltin/strmode.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/strmode.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/strmode.c	(revision 2113)
@@ -39,4 +39,5 @@
 #endif /* LIBC_SCCS and not lint */
 
+#include "config.h"
 /*#include "namespace.h"*/
 #include <sys/types.h>
Index: /trunk/src/kmk/kmkbuiltin/test.c
===================================================================
--- /trunk/src/kmk/kmkbuiltin/test.c	(revision 2112)
+++ /trunk/src/kmk/kmkbuiltin/test.c	(revision 2113)
@@ -16,4 +16,5 @@
 #endif*/
 
+#include "config.h"
 #include <sys/stat.h>
 #include <sys/types.h>